# coding: utf-8

"""
VMLab Backend

The VMLab Backend API

The version of the OpenAPI document: 0.1.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from slices_bi_client.models.network_interface_create import NetworkInterfaceCreate
from typing import Optional, Set
from typing_extensions import Self


class ComputeResourceCreate(BaseModel):
    """
    Request for a new Compute Resource.
    """  # noqa: E501

    disk_image: Optional[StrictStr] = None
    disk_image_id: Optional[Annotated[str, Field(strict=True)]] = None
    flavor: Optional[StrictStr] = None
    flavor_id: Optional[Annotated[str, Field(strict=True)]] = None
    friendly_name: Annotated[str, Field(strict=True)] = Field(
        description='User readable name, must conform to the following rules: - Can only contain alphanumeric characters (a-z A-Z 0-9) or a minus sign (-) - Must be at least 2 characters long, cannot be longer than 63 characters - Must not start or end with a minus sign (-) The name is "case preserving, but case insensitive".'
    )
    network_interfaces: Optional[List[NetworkInterfaceCreate]] = None
    site_id: Optional[StrictStr] = None
    userdata: Optional[Annotated[str, Field(strict=True, max_length=1048576)]] = None
    __properties: ClassVar[List[str]] = [
        "disk_image",
        "disk_image_id",
        "flavor",
        "flavor_id",
        "friendly_name",
        "network_interfaces",
        "site_id",
        "userdata",
    ]

    @field_validator("disk_image_id")
    def disk_image_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"image_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}", value):
            raise ValueError(
                r"must validate the regular expression /image_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}/"
            )
        return value

    @field_validator("flavor_id")
    def flavor_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"flavor_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}", value):
            raise ValueError(
                r"must validate the regular expression /flavor_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}/"
            )
        return value

    @field_validator("friendly_name")
    def friendly_name_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"[a-zA-Z0-9][a-zA-Z0-9-]{0,61}[a-zA-Z0-9]", value):
            raise ValueError(r"must validate the regular expression /[a-zA-Z0-9][a-zA-Z0-9-]{0,61}[a-zA-Z0-9]/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ComputeResourceCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in network_interfaces (list)
        _items = []
        if self.network_interfaces:
            for _item in self.network_interfaces:
                if _item:
                    _items.append(_item.to_dict())
            _dict["network_interfaces"] = _items
        # set to None if disk_image (nullable) is None
        # and model_fields_set contains the field
        if self.disk_image is None and "disk_image" in self.model_fields_set:
            _dict["disk_image"] = None

        # set to None if disk_image_id (nullable) is None
        # and model_fields_set contains the field
        if self.disk_image_id is None and "disk_image_id" in self.model_fields_set:
            _dict["disk_image_id"] = None

        # set to None if flavor (nullable) is None
        # and model_fields_set contains the field
        if self.flavor is None and "flavor" in self.model_fields_set:
            _dict["flavor"] = None

        # set to None if flavor_id (nullable) is None
        # and model_fields_set contains the field
        if self.flavor_id is None and "flavor_id" in self.model_fields_set:
            _dict["flavor_id"] = None

        # set to None if network_interfaces (nullable) is None
        # and model_fields_set contains the field
        if self.network_interfaces is None and "network_interfaces" in self.model_fields_set:
            _dict["network_interfaces"] = None

        # set to None if site_id (nullable) is None
        # and model_fields_set contains the field
        if self.site_id is None and "site_id" in self.model_fields_set:
            _dict["site_id"] = None

        # set to None if userdata (nullable) is None
        # and model_fields_set contains the field
        if self.userdata is None and "userdata" in self.model_fields_set:
            _dict["userdata"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ComputeResourceCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "disk_image": obj.get("disk_image"),
                "disk_image_id": obj.get("disk_image_id"),
                "flavor": obj.get("flavor"),
                "flavor_id": obj.get("flavor_id"),
                "friendly_name": obj.get("friendly_name"),
                "network_interfaces": [NetworkInterfaceCreate.from_dict(_item) for _item in obj["network_interfaces"]]
                if obj.get("network_interfaces") is not None
                else None,
                "site_id": obj.get("site_id"),
                "userdata": obj.get("userdata"),
            }
        )
        return _obj
